import ease from 'rx-ease';
import { BehaviorSubject, Observable, combineLatest, of } from 'rxjs';
import 'rxjs/operators';

var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



































var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var curry = function curry(f) {
  return function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return args.length >= f.length ? f.apply(undefined, args) : function () {
      for (var _len4 = arguments.length, args2 = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args2[_key4] = arguments[_key4];
      }

      return curry(f).apply(undefined, args.concat(args2));
    };
  };
};

var all = function all(obs) {
  return obs.length ? combineLatest.apply(undefined, toConsumableArray(obs).concat([function () {
    for (var _len = arguments.length, xs = Array(_len), _key = 0; _key < _len; _key++) {
      xs[_key] = arguments[_key];
    }

    return xs;
  }])) : of([]);
};



var raf = new Observable(function (observer) {
  var isSubscribed = true;

  var loop = function loop() {
    if (isSubscribed) {
      observer.next();
      window.requestAnimationFrame(loop);
    }
  };

  window.requestAnimationFrame(loop);

  return {
    unsubscribe: function unsubscribe() {
      isSubscribed = false;
    }
  };
});

var mapValues = curry(function (f, obj) {
  return Object.keys(obj).reduce(function (acc, k) {
    return _extends({}, acc, defineProperty({}, k, f(obj[k], k)));
  }, {});
});

var createMutable = function createMutable(initialValue) {
  var sub = new BehaviorSubject(initialValue);
  sub.set = function (x) {
    return sub.next(typeof x === 'function' ? x(sub.value) : x);
  };
  return sub;
};

function createState(initialState) {
  return mapValues(createMutable, initialState);
}

export { ease, createState, all };
